# -*- coding: utf-8 -*-
"""
Created on Tue Feb 20 15:36:06 2024

@author: migue
"""

import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.cm as cm
import seaborn as sns
import numpy as np


year = 2018
excel_file_path = f'C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\gopi{year}subseccao.xlsx'
ocorrencias = pd.read_excel(excel_file_path)

ocorrencias['dt_registo'] = pd.to_datetime(ocorrencias['dt_registo'], format='%Y-%m-%d')

#Import all years 

years = [e for e in range(2017, 2024)]

dfs = []

for year in years:
    excel_file_path = f'C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\gopi{year}subseccao.xlsx'
    df = pd.read_excel(excel_file_path)
    dfs.append(df)

ocorrencias = pd.concat(dfs, axis=0)

ocorrencias['Ano'] = year
ocorrencias['dt_registo'] = pd.to_datetime(ocorrencias['dt_registo'], format='%Y-%m-%d')

tipos = ocorrencias['tipo'].unique()

areas = ocorrencias['area'].unique()

ocorrencias.info()

tipos_valores = ocorrencias['tipo'].value_counts()

value_counts_por_ano = ocorrencias.groupby(['Ano', 'tipo']).size().unstack(fill_value=0)

'''
#Check for duplicate coordinates to check for reocurring ocurrences in sequential days
coordenado = ocorrencias.sort_values(by=['Latitude_Subseccao', 'Longitude_Subseccao', 'tipo'])

# Find duplicates based on both latitude and longitude
duplicate_rows = coordenado[coordenado.duplicated(subset=['Latitude_Subseccao', 'Longitude_Subseccao', 'tipo'], keep=False)]

#Lets see

consecutive_occurrences = pd.DataFrame(columns=ocorrencias.columns)

grouped = ocorrencias.groupby(['Latitude_Subseccao', 'Longitude_Subseccao', 'tipo'])

# Iterate over groups and check for consecutive dates
consecutive_counts = {}
for group_name, group_data in grouped:
    group_data = group_data.sort_values(by='dt_registo')  # Ensure data is sorted by date
    consecutive_indices = []
    for i in range(len(group_data) - 1):
        if (group_data.iloc[i + 1]['dt_registo'] - group_data.iloc[i]['dt_registo']) in [pd.Timedelta(days=1),
                                                                              pd.Timedelta(days=2),
                                                                              pd.Timedelta(days=3)]:
            consecutive_indices.extend([i, i + 1])
    consecutive_counts[group_name] = len(consecutive_indices) // 2 
    consecutive_occurrences = pd.concat([consecutive_occurrences, group_data.iloc[consecutive_indices]])


result_df = pd.DataFrame(list(consecutive_counts.items()), columns=['Group', 'Group Size'])

# Count the number of groups for each group size
result_df = result_df.groupby('Group Size').size().reset_index(name='Number of Groups')


consecutive_occurrences.drop_duplicates(inplace=True)

# test 

group_sizes = grouped.size().reset_index(name='Group Size')

total_sum = ((result_df['Group Size'] + 1) * result_df['Number of Groups']).sum()
'''

areas_tipos = ocorrencias.drop_duplicates(['area','tipo'])

areas_tipos = areas_tipos[['area','tipo']].sort_values('area')

areas_tipos.loc[areas_tipos['area'].isin(['Estradas e Ciclovias','Estradas e Sinalização']),
                'area'] = 'Estradas/Ciclovias/Sinalizacao'

areas_tipos = areas_tipos.drop_duplicates(['area','tipo'])

tipos_dupe = areas_tipos[areas_tipos.duplicated('tipo', keep = False)]

analise = areas_tipos.drop_duplicates('tipo', keep = False)

ntipos = ocorrencias['tipo'].value_counts()

analise = analise.sort_values(['area','tipo'])

areas_tipos2 = ocorrencias.drop_duplicates(['area','tipo'])

areas_tipos2 = areas_tipos2[['area','tipo']].sort_values(['area','tipo'])

#Graficos 
exploracao = ocorrencias[['Freguesia','Ano']]

exploracao['Freguesia'].value_counts().plot(kind='bar')
plt.title('Número de ocorrências por freguesia')
plt.ylabel('Número de ocorrências')
plt.show()


heatmap_data = exploracao.pivot_table(index='Ano', columns='Freguesia', aggfunc='size', fill_value=0)

# Plot heatmap
plt.figure(figsize=(10, 6))
sns.heatmap(heatmap_data, annot=True, cmap='YlGnBu')

# Add title and labels
plt.title('Heatmap de ocorrências por ano por freguesia')
plt.xlabel('Freguesia')
plt.ylabel('Ano')

# Show plot
plt.show()


ocorrencias['area'].value_counts().plot(kind='bar')
plt.title('Número de ocorrências por area')
plt.ylabel('Número de ocorrências')
plt.xlabel('Area')
plt.show()

heatmap_data_percentage = heatmap_data.div(heatmap_data.sum(axis=1), axis=0) * 100

# Plot heatmap
plt.figure(figsize=(10, 6))
ax = sns.heatmap(heatmap_data_percentage, annot=True, fmt=".1f", cmap='rocket_r', cbar=False)  # Remove color bar

# Add total counts on the side
for i, (year, row) in enumerate(heatmap_data.iterrows()):
    total_count = row.sum()
    plt.text(len(heatmap_data.columns) + 0.5, i + 0.5, f'Total: {total_count}', va='center')

# Add title and labels
plt.title('Heatmap de ocorrências por freguesia (Percentagem)')
plt.xlabel('Freguesia')
plt.ylabel('Ano')

ax.hlines(list(range(9)), *ax.get_xlim(), colors='white', linewidth=22)

# Show plot
plt.show()

## Pie charts (tipos)

value_counts = ocorrencias['tipo'].value_counts()

# Calculate total occurrences
total_occurrences = value_counts.sum()

# Filter out values less than 2% of total occurrences
filtered_value_counts = value_counts[value_counts / total_occurrences >= 0.02]

# Sum up values less than 2% and create 'Other' category
other_count = value_counts[value_counts / total_occurrences < 0.02].sum()
filtered_value_counts['Outro'] = other_count
n = len(filtered_value_counts)

colors = cm.Paired(np.linspace(0, 1, n))

# Plot pie chart
plt.figure(figsize=(8, 8))
#plt.pie(value_counts, labels=value_counts.index, autopct='%1.1f%%', colors=colors)
plt.pie(filtered_value_counts, labels=filtered_value_counts.index, autopct='%1.1f%%', colors=colors)
plt.title('Ocorrências por tipo')
plt.show()

## Cloropeth...
import geopandas as gpd
import folium 
from branca.colormap import StepColormap, LinearColormap

geo_json_data = gpd.read_file('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\Limite_Cartografia.geojson')

count_df = ocorrencias.groupby('Freguesia').size().reset_index(name='Ocorrencias')

# Merge count_df with geo_json_data on the common column "Freguesia"/"NOME"
merged_data = pd.merge(geo_json_data, count_df, left_on='NOME', right_on='Freguesia', how='left')

# Initialize Folium map centered at the mean of latitude and longitude of the GeoJSON data
m = folium.Map(location=[geo_json_data.geometry.centroid.y.mean(), geo_json_data.geometry.centroid.x.mean()], zoom_start=12.5, tiles=None)

'''
# Add choropleth layer to the map using the count of rows as the value to display
folium.Choropleth(
    geo_data=merged_data,
    data=merged_data,
    columns=['NOME', 'Ocorrencias'],  # Use 'NOME' from GeoJSON file and 'Count' from the merged DataFrame
    key_on='feature.properties.NOME',  # Specify the key_on parameter as 'feature.properties.NOME'
    fill_color='YlGn',  # Choose color scale
    fill_opacity=1,
    line_opacity=0.2,
    highlight=True,
    legend_name='Numero de Ocorrencias',
).add_to(m)
'''
linear_colormap = LinearColormap(
    colors=['#fff5eb', '#fee6ce', '#fdd0a2', '#fdae6b', '#fd8d3c', '#f16913', '#d94801', '#8c2d04'],
    vmin=0,
    vmax=merged_data['Ocorrencias'].max(),
    caption='Numero de Ocorrencias'  # Caption for the legend
)

# Add GeoJson with custom style function using the colormap
folium.GeoJson(
    merged_data,
    style_function=lambda feature: {
        'fillColor': linear_colormap(feature['properties']['Ocorrencias']),
        'color': 'black',
        'weight': 1,
        'fillOpacity': 1,
    },
    tooltip=folium.GeoJsonTooltip(fields=['NOME', 'Ocorrencias'])
).add_to(m)

# Add the colormap to the map
linear_colormap.add_to(m)
'''
for _, row in merged_data.iterrows():
    folium.map.Marker(
        [row.geometry.centroid.y, row.geometry.centroid.x],
        icon=folium.DivIcon(html=f'<div style="font-size: 7pt">{row["NOME"]}</div>'),
        localize=True,
        sticky=True
    ).add_to(m)
'''
    
# Display map
m.save('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\choropleth_map.html')

# Subseccoes
subs = ocorrencias[['Latitude_Subseccao','Longitude_Subseccao']].drop_duplicates()

mymap = folium.Map(location=[subs['Latitude_Subseccao'].mean(), subs['Longitude_Subseccao'].mean()], zoom_start=4)

# Add markers for each latitude and longitude pair
for index, row in subs.iterrows():
    folium.Marker([row['Latitude_Subseccao'], row['Longitude_Subseccao']]).add_to(mymap)

# Save the map as an HTML file
mymap.save("map.html")
#Exploração freguesias

top_tipo = ocorrencias.groupby('Freguesia')['tipo'].value_counts().reset_index(name='count')

# Sort values by 'Freguesia' and 'count' in descending order
top_tipo = top_tipo.sort_values(by=['Freguesia', 'count'], ascending=[True, False])

# Plot table for each Freguesia
# Plot table for each Freguesia
for freguesia, df in top_tipo.groupby('Freguesia'):
    plt.figure(figsize=(10, 4))
    ax = plt.subplot(111, frame_on=False)
    ax.xaxis.set_visible(False)
    ax.yaxis.set_visible(False)
    table = plt.table(cellText=df.head(10).drop(columns='Freguesia').values,
                      colLabels=['Tipo', 'Count'],
                      colWidths=[0.3, 0.2],
                      colColours=['lightgrey']*2,
                      loc='center')
    table.auto_set_font_size(False)
    table.set_fontsize(14)
    table.scale(1, 1.5)
    plt.title(f'Top 10 Tipos for Freguesia {freguesia}')
    plt.show()

top_10_df = pd.DataFrame(columns=['Freguesia', 'tipo', 'count'])

# Iterate over groups and concatenate the top 10 rows of each group
for freguesia, df in top_tipo.groupby('Freguesia'):
    top_10_df = pd.concat([top_10_df, df.head(10)], ignore_index=True)
    
#Residentes

residentes = {
    'Freguesia': ['Ajuda', 'Alcântara', 'Alvalade', 'Areeiro', 'Arroios', 'Avenidas Novas', 
                  'Beato', 'Belém', 'Benfica', 'Campo de Ourique', 'Campolide', 'Carnide', 
                  'Estrela', 'Lumiar', 'Marvila', 'Misericórdia', 'Olivais', 'Parque das Nações', 
                  'Penha de França', 'Santa Clara', 'Santa Maria Maior', 'Santo António', 
                  'São Domingos de Benfica', 'São Vicente'],
    'Residentes': [14306, 13850, 33309, 21160, 33302, 23261, 12183, 16546, 35362, 22140, 
                   14787, 18028, 20267, 46334, 35479, 9658, 32179, 22382, 28475, 23645, 
                   10051, 11060, 34076, 13956]
    }

residentes_df = pd.DataFrame(residentes)

ocorrencias_count = ocorrencias.groupby('Freguesia').size().reset_index(name='Ocorrencias')

# Merge counts with residentes dataframe on 'Freguesia'
merged_df = pd.merge(ocorrencias_count, residentes_df, on='Freguesia')

# Calculate the ratio
merged_df['Ratio'] = merged_df['Ocorrencias'] / merged_df['Residentes']

correlation = merged_df['Ocorrencias'].corr(merged_df['Residentes'])

print("Correlation between Ocorrencias and Residentes:", correlation)

#Monthly

ocorrencias_monthly = ocorrencias.resample('M', on='dt_registo').size().reset_index(name='count')

# Plotting the line chart
plt.figure(figsize=(10, 6))
plt.plot(ocorrencias_monthly['dt_registo'], ocorrencias_monthly['count'], linestyle='-')
plt.title('Occurrences per Month')
plt.xlabel('Month')
plt.ylabel('Occurrences')
plt.tight_layout()
plt.show()

#Cumsum

novo = ocorrencias.set_index('dt_registo')

# Sort DataFrame by index
novo.sort_index(inplace=True)

# Calculate cumulative count of occurrences
novo['cumulative_count'] = range(1, len(novo) + 1)

# Plotting the cumulative count
plt.figure(figsize=(10, 6))
plt.plot(novo.index, novo['cumulative_count'], linestyle='-')
plt.fill_between(novo.index, novo['cumulative_count'], color='skyblue', alpha=0.4)
plt.title('Contagem cumulativa de ocorrências')
plt.xlabel('Data')
plt.ylabel('Ocorrências')
plt.tight_layout()
plt.show()