# Preparação dos dados
from Exploracao import ocorrencias
import pandas as pd
import numpy as np
import matplotlib as plt

category_mapping = {
    'Desinfestação (ratos, insetos)': ['Desbaratização em propriedade privada',
                                       'Desbaratização na via pública ou coletores',
                                       'Desinfestação em propriedade privada',
                                       'Desinfestação na via pública ou coletores',
                                       'Desratização em propriedade privada',
                                       'Desratização na via pública ou coletores',
                                       'Enxame de abelhas ou vespas'],
    
    'Recolha animais vivos': ['Recolha de animais de pequeno e médio porte vivos em propriedade privada',
                              'Recolha de animais de pequeno e médio porte vivos na via pública'],
    
    'Recolha animais mortos': ['Recolha de animais de pequeno e médio porte mortos ou acidentados, na via pública',
                               'Recolha de animais de pequeno e médio porte mortos ou doentes em propriedade privada'],

    'Animais (Outros)': ['Problemas com pombos em meio urbano',
                         'Reclamações sobre as áreas de animais e pragas',
                         'Requerimento para detenção de animais em quantidade superior à legal'],
    
    'Danos na via': ['Abatimentos - Pesquisas urgentes',
                     'Abatimentos superficiais',
                     'Betuminoso',
                     'Betão',
                     'Buraco envolvente à tampa de saneamento - Betuminoso',
                     'Buraco na faixa de rodagem - Betuminoso',
                     'Buraco na faixa de rodagem - Betão',
                     'Buraco na faixa de rodagem - Cubos',
                     'Buracos em Betuminoso',
                     'Cubos',
                     'Pavimentação',
                     'Recargas em Betuminoso',
                     'Repavimentação'],
    
    'Dispositivos complementares': ['Balizadores',
                                    'Dispositivos complementares (Balizadores)',
                                    'Dispositivos complementares (Balizadores,...) - Manutenção',
                                    'Dispositivos de segurança (balizadores, lombas e bandas sonoras) - Novo',
                                    'Dispositivos de segurança (balizadores, lombas e separadores de faixa de rodagem) - Manutenção',
                                    'Irregularidades (lombas) - Betuminoso',
                                    'Lombas ou bandas sonoras',
                                    'Lombas ou bandas sonoras - Manutenção'
                                    'Novos dispositivos complementares (Balizadores, Lombas,...)',
                                    'Novos dispositivos complementares (Balizadores,...)',
                                    'Pilaretes',
                                    'Recolha de patas de elefante',
                                    'Separadores e proteções de faixa de rodagem',
                                    'Separadores e proteções de faixa de rodagem - Manutenção'],
    
    'Lancil/Passadeiras': ['lancil',
                 'Lancil de segurança danificado ou em falta',
                 'Novas Passadeiras ou outras sinalizações horizontais',
                 'Passadeira sobrelevada',
                 'Repintura de passadeiras ou outras sinalizações horizontais',
                 'Sinalização horizontal',
                 'Sinalização horizontal e passadeiras - Manutenção',
                 'Sinalização horizontal e passadeiras - Novo, remoção e reposicionamento'],
    
    'Manuntenção itens externos': ['Caixas técnicas SLAT - Manutenção',
                                   'Carris - Equipamento informativo',
                                   'Concessionárias - Danos e obras'],
    
    'Ciclovias': ['Ciclovia - Construção',
                  'Ciclovia - Manutenção',
                  'Ciclovias - Construção',
                  'Ciclovias- Nova'],
    
    'Construção de Infrastrutura': ['Construção',
                   'Construção de estacionamento',
                   'Construção de estacionamento tarifado',
                   'Reconstrução',
                   'Viadutos, passagens superiores e inferiores',
                   'Viadutos, passagens superiores e inferiores - Estrutura',
                   'Viadutos, passagens superiores e inferiores - Manutenção'],
    
    'Sinalização vertical': ['Espelho parabólico',
                    'Novos sinais de trânsito e outra sinalização vertical',
                    'Retirada definitiva de sinais de trânsito e outra sinalização vertical',
                    'Semáforos - Manutenção',
                    'Semáforos - Novo',
                    'Semáforos e sinais luminosos em falta ou para manutenção',
                    'Sinais de trânsito e outra sinalização vertical - Manutenção',
                    'Sinais informativos em falta ou para manutenção',
                    'Sinais informativos luminosos - Manutenção',
                    'Sinalização informativa e/ou turística',
                    'Sinalização vertical',
                    'Sinalização vertical incluindo informativa - Manutenção',
                    'Sinalização vertical incluindo informativa - Novo, remoção e reposicionamento'],
    
    'Estacionamentos': ['Estacionamento de motas - Construção',
                        'Estacionamento de motas - Construção',
                        'Estacionamento de motas - Novo, remoção e reposicionamento',
                        'Estacionamento de velocípedes - Manutenção',
                        'Estacionamento de velocípedes - Manutenção',
                        'Parqueamento de bicicletas - Construção',
                        'Parqueamento de bicicletas - Manutenção',
                        'Parqueamento de motas - Construção',
                        'Parqueamento de motas - Manutenção'],
    
    'Outros (Estradas)': ['Estabilização de obras de arte',
                          'Fresagem de Betuminoso',
                          'Grelhas de saneamento',
                          'Manutenção de Equipamento',
                          'Reclamações no âmbito da gestão de trânsito',
                          'Requalificação'
                          'Sarjetas',
                          'Tampas de saneamento'],
    
    'Recolhas (Monos/Monstros)': ['Agendamento de recolha de monos',
                                  'Entulhos, objetos volumosos, resíduos de jardim ou perigosos abandonados na via pública',
                                  'Recolha de resíduos de árvores na via pública, decorrente de ação de emergência do RSB',
                                  'Remoção-Jardins-Pedido de recolha',
                                  'Remoção-Monstros-Pedido de recolha',
                                  'Remoção-RCD-Pedido de recolha'],
    
    'Alterar recolha (lixo)': ['Alteração da periodicidade da recolha de ecoponto ou vidrão',
                               'Alteração do local de remoção de contentor de pequena capacidade (2 rodas)',
                               'Falta de despejo do contentor de pequena capacidade (2 rodas) ou sacos (municipais)',
                               'Reclamações no âmbito da recolha diária de resíduos sólidos urbanos',
                               'Remoção Seletivas - Remoção pontual de papel/cartão',
                               'Remoção-Seletivas-Remoção pontual de papel/cartão',
                               'Sacos ou outros lixos abandonados'],
    
    'Danos e arranjos (lixo)': ['Arranjo de papeleiras',
                                'Boca de incêndio danificada devido à limpeza de arruamento',
                                'Contentor coletivo (4 rodas) danificado',
                                'Contentor de pequena capacidade (2 rodas) danificado',
                                'Contentores de resíduos danificados',
                                'Substiruição de ecoponto ou vidrão devido a incêndio',
                                'Substituição de contentor coletivo (4 rodas) devido a incêndio',
                                'Substituição de contentor de pequena capacidade (2 rodas) devido a incêndio',
                                'Substituição de ecoponto ou vidrão devido a incêndio',
                                'Substituição ou reparação de ecoponto, vidrão ou ecoilha danificados',
                                'Substituição ou reparação de papeleira danificada',
                                'Substituição ou reparação de papeleira queimada'],
    
    'Contentor desaparecido/fora': ['Contentor coletivo (4 rodas) fora do local',
                                    'Contentor de pequena capacidade (2 rodas) abandonado na via',
                                    'Contentor de pequena capacidade (2 rodas) desaparecido',
                                    'Contentores na via pública fora do horário regulamentar',
                                    'Deslocação de ecoponto ou vidrão',
                                    'Devolução de contentor de pequena capacidade (2 rodas)'],
    
    'Limpeza': ['Grafitis',
                'Insalubridade - Via - Pedido de intervenção',
                'Insalubridade em propriedades ou terrenos',
                'Lavagem de ecoponto ou vidrão',
                'Limpeza da via pública',
                'Limpeza da via pública (Despejo de papeleira, varredura e lavagem da via pública)',
                'Limpeza da via pública (Varredura e/ou lavagem)',
                'Limpeza da via pública (Varredura, despejo de papeleira e/ou lavagem)',
                'Limpeza da via pública devido a acidente de trânsito',
                'Limpeza de dejetos caninos',
                'Limpeza e remoção de grafítis em ecoponto ou vidrão',
                'Limpeza em redor de ecoponto ou vidrão',
                'Necessidade de limpeza da via pública devido a ocorrência imprevista',
                'Reclamações sobre a área da limpeza pública'],
    
    'Outros (lixo)': ['Contaminação dos resíduos depositados selectivamente',
                      'Corte de ervas em passeios',
                      'Fiscalização de dejetos caninos',
                      'Fornecimento de alimento a animais na via pública',
                      'Outras situações de sacos, pilhões, fitas ou papeleiras',
                      'Postos de limpeza - Manutenção e/ou reparação',
                      'Pragas e doenças',
                      'Resíduos em torno de ecoponto e vidrões',
                      'Retirada de ecoponto ou vidrão',
                      'Rotura e/ou desentupimento',
                      'Situações com contentores de grande capacidade ( 5000 L )'],
    
    'Falta de luminosidade': ['Arruamento com luz insuficiente',
                              'Arruamento às escuras',
                              'Fiscalização - 	Arruamento com luz insuficiente',
                              'Fiscalização - Arruamento às escuras'],
    
    'Candeeiro desfuncional': ['Candeeiro apagado',
                               'Candeeiro com luz intermitente',
                               'Candeeiro danificado (caído, partido, cabos elétricos à vista, falta de portinhola, etc)',
                               'Fiscalização - Candeeiro apagado',
                               'Fiscalização - Candeeiro com luz intermitente',
                               'Fiscalização - Candeeiro danificado'],
    
    'Outros (Iluminação)': ['Fiscalização - 	Monumento (Manutenção em iluminação)',
                            'Fiscalização - 	Outras situações',
                            'Monumento - Manutenção em iluminação',
                            'Outras situações'],
    
    'Passeio/Acesso danificado': ['Abatimentos - Pesquisas',
                                  'Abatimentos superficiais',
                                  'Betuminoso',
                                  'Betão ou outros revestimentos',
                                  'Buraco no passeio - Betuminoso',
                                  'Buraco no passeio - Betão ou outros revestimentos',
                                  'Buraco profundo (sem água)',
                                  'Caleira danificada em passeios',
                                  'Caleira no passeio - Construção',
                                  'Calçada artística',
                                  'Calçada artística - Manutenção',
                                  'Descalcetamento do passeio',
                                  'Passeio - Reconstrução/Construção',
                                  'Pedra calcária'],
    
    'Infraestrutura publica': ['Abrigos concessionados de paragens de transportes públicos - Construção',
                               'Abrigos concessionados de paragens de transportes públicos - Manutenção',
                               'Abrigos não concessionados de paragens de transportes públicos - Manutenção',
                               'Acessos para cidadãos com mobilidade reduzida',
                               'Bebedouros - Manutenção',
                               'Bebedouros, Chafariz, Fontanário ou Lago - Manutenção',
                               'Colocação de novo mobiliário urbano',
                               'Colocação de novos pilaretes',
                               'Concessionárias - Danos e obras',
                               'Corrimãos, guardas ou gradeamentos - Construção',
                               'Corrimãos, guardas ou gradeamentos - Manutenção',
                               'Elementos de água (exceto bens culturais imóveis) - Manutenção',
                               'Escadas - Manutenção',
                               'Interface de transportes (Manutenção)',
                               'Marcos e bocas de incêndio (Fuga de água)',
                               'Marcos e bocas de incêndio danificados',
                               'Mesas, bancos ou outro mobiliário urbano - Manutenção',
                               'Metropolitano - Manutenção de equipamento',
                               'Mobiliário urbano com publicidade - Manutenção',
                               'Outros revestimentos artísticos - Manutenção',
                               'Pilaretes',
                               'Pilaretes - Manutenção',
                               'Placa toponímica danificada ou em falta',
                               'Plano Geral de Drenagem de Lisboa - Danos e obras',
                               'Quiosques - Manutenção',
                               'Reparação de Hidrantes',
                               'Retirada definitiva de mobiliário urbano'],
    
    'Outros (passeios)': ['Caixas técnicas SLAT - Manutenção', #Alguns verificar pra meter na estrada, ect (pilaretes acima)
                          'Ciclovias - Manutenção',
                          'Ciclovias - Manutenção preventiva',
                          'Fiscalização técnica da ocupação do espaço público- Esplanadas abertas e toldos',
                          'Lancil danificado ou em falta'],
    
    'Abatimentos (esgoto)': ['Abatimentos profundos',
                             'Abatimentos profundos - Pesquisas urgentes'],
    
    'Danos (saneamento)': ['Buraco envolvente à tampa de saneamento - revestimento cimentício',             # Ver estrada ha semelhantes
                           'Coletor/ramal de esgoto danificado',
                           'Entupimento de sarjeta ou sumidouro',
                           'Fuga de água potável em espaço público',
                           'Grelha de sumidouro danificada ou em falta',
                           'Obstrução de coletor/ramal de esgoto',
                           'Sarjeta danificada',
                           'Sumidouro/Sarjeta - Construção nova',
                           'Tampa de esgoto danificada ou desnivelada',
                           'Tampa de esgoto em falta'],
    
    'Inundação': ['Inundação em espaço público ou esgoto na via',
                  'Inundação em espaço público ou esgoto na via (exceto fuga de água)',
                  'Obstrução de coletor/ramal de esgoto, inundação em espaço público ou esgoto na via'],  #Separar obstrucao e inundacao? ou outra coluna
    
    'Limpeza (esgoto)': ['Limpeza mecânica de caixa de esgoto',
                         'Limpeza mecânica de sargeta e/ou sumidouro',
                         'Limpeza mecânica de sarjeta e/ou sumidouro'],
    
    'Abate e corte': ['Abate e corte de cepos',
                      'Abate, corte de cepos e novas plantações de árvores'],
    
    'Desmatação': ['Desmatação de terrenos municipais com área < 5.000 m2 e inclinação < 25%',
                   'Desmatação de terrenos municipais com área > 5.000m2 ou inclinação > 25%'],
    
    'Manuntenção espaço verde': ['Equipamento - Manutenção e/ou reparação',
                          'Espaços verdes Manutenção',
                          'Espaços verdes particulares - Manutenção',
                          'Hortas urbanas - Manutenção',
                          'Manutenção e/ou reparação',
                          'Parques Infantis e Juvenis - Manutenção',
                          'Pragas e doenças em espaços verdes',
                          'Rede de rega - Manutenção',
                          'Árvores – Plantação',
                          'Árvores, arbustos ou relva - Manutenção'],
    
    'Outros (arvores)': ['Bebedouros, Chafariz, Fontanário ou Lago - Manutenção', #Juntar a infraestrutura publica?
                         'Casas de função - Manutenção ou reparação',
                         'Cercas, vedações e outras estruturas - Manutenção',
                         'Ciclovias - Construção',
                         'Ciclovias - Manutenção',
                         'Colocação de novo mobiliário urbano',
                         'Mesas, bancos ou outro mobiliário urbano - Manutenção',
                         'Construção de Parques Infantis e Juvenis', # É daqui
                         'Construção de espaços verdes', # É daqui
                         'Criação de novos espaços verdes',
                         'Entupimento de sarjeta ou sumidouro em espaços estruturantes', #Juntar a saneamento
                         'Indemnização por danos em propriedade particular causados por queda de árvores', # É daqui
                         'Limpeza (papeleiras, embalagens, ...)', #Saneamento
                         'Recolha de objetos volumosos (monos) abandonados em área da Estrutura Verde',
                         'Rotura e/ou desentupimento']
}


# Create a function to map types to categories
def map_to_category(type_value):
    for category, types in category_mapping.items():
        if type_value in types:
            return category
    return None  # If type doesn't match any category

# Create a new column 'category' based on 'type' column
ocorrencias['entre_area_tipo'] = ocorrencias['tipo'].apply(map_to_category)


'''
#Reocorrentes
#Check for duplicate coordinates to check for reocurring ocurrences in sequential days
coordenado = ocorrencias.sort_values(by=['Subseccao', 'tipo'])

# Find duplicates based on both latitude and longitude
duplicate_rows = coordenado[coordenado.duplicated(subset=['Subseccao', 'tipo'], keep=False)]

#Lets see

consecutive_occurrences = pd.DataFrame(columns=ocorrencias.columns)

grouped = ocorrencias.groupby(['Subseccao', 'tipo'])

# Iterate over groups and check for consecutive dates
consecutive_counts = {}
for group_name, group_data in grouped:
    group_data = group_data.sort_values(by='dt_registo')  # Ensure data is sorted by date
    consecutive_indices = []
    group = 1
    for i in range(len(group_data) - 1):
        if (group_data.iloc[i + 1]['dt_registo'] - group_data.iloc[i]['dt_registo']) in [pd.Timedelta(days=1),
                                                                              pd.Timedelta(days=2),
                                                                              pd.Timedelta(days=3)]:
            consecutive_indices.extend([i, i + 1])
            
        group += 1
    consecutive_counts[group_name] = len(consecutive_indices) // 2 
    consecutive_occurrences = pd.concat([consecutive_occurrences, group_data.iloc[consecutive_indices]])


result_df = pd.DataFrame(list(consecutive_counts.items()), columns=['Group', 'Group Size'])

# Count the number of groups for each group size
result_df = result_df.groupby('Group Size').size().reset_index(name='Number of Groups')


consecutive_occurrences.drop_duplicates(inplace=True)

# test 

group_sizes = grouped.size().reset_index(name='Group Size')

total_sum = ((result_df['Group Size'] + 1) * result_df['Number of Groups']).sum()
'''


## REDO

tipos = ocorrencias[ocorrencias['tipo'] == '']

ocorrencias.reset_index(drop=True, inplace=True)

coordenado = ocorrencias.sort_values(by=['Subseccao', 'tipo'])

# Find duplicates based on both latitude and longitude
duplicate_rows = coordenado[coordenado.duplicated(subset=['Subseccao', 'tipo'], keep=False)]

#Lets see

grouped = duplicate_rows.groupby(['Subseccao', 'area', 'tipo'])
grouped = grouped.filter(lambda x: len(x) > 1)
grouped = grouped.groupby(['Subseccao', 'tipo'])

reocorrentes = pd.DataFrame(columns=list(ocorrencias.columns) + ['Group'])

group = 0
# Iterate over groups and check for consecutive dates
for group_name, group_data in grouped:
    group_data = group_data.sort_values(by='dt_registo')
    group_data['Group'] = np.nan
    group += 1
    for i in range(len(group_data) - 1):
        if group_data.iloc[i + 1]['dt_registo'] == group_data.iloc[i]['dt_registo'] or (group_data.iloc[i + 1]['dt_registo'] - group_data.iloc[i]['dt_registo']) in [pd.Timedelta(days=1), 
                                                                                                                                                                    pd.Timedelta(days=2), 
                                                                                                                                                                    pd.Timedelta(days=3)]:
            group_data.at[group_data.index[i], 'Group'] = group
            group_data.at[group_data.index[i + 1], 'Group'] = group 
        else:
            group += 1
    reocorrentes = pd.concat([reocorrentes, group_data], ignore_index=False)
    reocorrentes = reocorrentes.dropna(subset=['Group'])
    
reocorrentes.to_csv('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\reocorrentes.csv', index=False)
        
grouped_df = reocorrentes.groupby('Group')

# Define aggregation functions for all variables
aggregation_functions = {col: 'first' for col in reocorrentes.columns if col not in ['dt_registo', 'Ano']}

# Extract start_date, end_date, and count for each group
start_dates = grouped_df['dt_registo'].first()
end_dates = grouped_df['dt_registo'].last()
number_of_rows = grouped_df.size()

# Merge start_date, end_date, number_of_rows with other variables
hotspots = pd.DataFrame()
hotspots['primeiro_registo'] = start_dates.values
hotspots['ultimo_registo'] = end_dates.values
hotspots['numero_ocorrencias'] = number_of_rows.values

# Merge other variables using the 'first' aggregation function
for col, func in aggregation_functions.items():
    hotspots[col] = grouped_df[col].agg(func).values


'''
#REDO 2

coordenado = ocorrencias.sort_values(by=['Subseccao', 'tipo'])

# Find duplicates based on both latitude and longitude
duplicate_rows = coordenado[coordenado.duplicated(subset=['Subseccao', 'tipo'], keep=False)]

#Lets see

grouped = duplicate_rows.groupby(['Subseccao', 'area', 'tipo'])

reocorrentes = pd.DataFrame(columns=list(ocorrencias.columns) + ['Group'])

group = 1
# Iterate over groups and check for consecutive dates
for group_name, group_data in grouped:
    group_data = group_data.sort_values(by='dt_registo')
    group_data['Group'] = np.nan 
    prev_i = None
    for i in range(len(group_data)):
        if prev_i is not None:
            if (group_data.iloc[i]['dt_registo'] - group_data.iloc[prev_i]['dt_registo']) in [pd.Timedelta(days=1),
                                                                                               pd.Timedelta(days=2),
                                                                                               pd.Timedelta(days=3)]:
                group_data.at[group_data.index[prev_i], 'Group'] = group
                group_data.at[group_data.index[i], 'Group'] = group
            else:
                group += 1
                group_data.at[group_data.index[i], 'Group'] = group
        else:
            group_data.at[group_data.index[i], 'Group'] = group
        prev_i = i
    reocorrentes = pd.concat([reocorrentes, group_data], ignore_index=False)
        
reocorrentes = reocorrentes.dropna(subset=['Group'])
    
reocorrentes.to_csv('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\reocorrentes.csv', index=False)
        
grouped_df = reocorrentes.groupby('Group')

# Define aggregation functions for all variables
aggregation_functions = {col: 'first' for col in reocorrentes.columns if col not in ['dt_registo', 'Ano']}

# Extract start_date, end_date, and count for each group
start_dates = grouped_df['dt_registo'].first()
end_dates = grouped_df['dt_registo'].last()
number_of_rows = grouped_df.size()

# Merge start_date, end_date, number_of_rows with other variables
hotspots = pd.DataFrame()
hotspots['primeiro_registo'] = start_dates.values
hotspots['ultimo_registo'] = end_dates.values
hotspots['numero_ocorrencias'] = number_of_rows.values

# Merge other variables using the 'first' aggregation function
for col, func in aggregation_functions.items():
    hotspots[col] = grouped_df[col].agg(func).values
    '''
    
#Distribuicao / Exploracao hotspots

valoreshs = hotspots['numero_ocorrencias'].value_counts()

hotspots['duracao'] = (hotspots['ultimo_registo'] - hotspots['primeiro_registo']).dt.days + 1

hotspots['racio_ocorrencias_por_dia'] = hotspots['numero_ocorrencias']/hotspots['duracao']

hotspots.to_csv('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\hotspots.csv', index=False)
#Grafico
data_values = hotspots['racio_ocorrencias_por_dia'].value_counts()

# Plot histogram of the actual data
plt.hist(data_values, density=True, alpha=0.6, color='g')


plt.title('Data Distribution and Fitted Normal Distribution')
plt.xlabel('Value')
plt.ylabel('Density')

plt.show()