# -*- coding: utf-8 -*-
"""
Created on Fri May  3 11:11:58 2024

@author: migue
"""
import pandas as pd
import matplotlib.pyplot as plt
import geopandas as gpd

gdfss = gpd.read_file('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\BGRI2021_1106.gpkg')
gdfss = gdfss.rename(columns={'SUBSECCAO': 'Subseccao'})
gdfss['Subseccao'] = gdfss['Subseccao'].astype('int64')

csv_file_path = 'C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\hotspots.csv'
hotspots = pd.read_csv(csv_file_path)


csv_file_path = 'C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\reocorrentes.csv'
reocorrentes = pd.read_csv(csv_file_path)

hotspots = hotspots[(hotspots['numero_ocorrencias'] >= 5) & (hotspots['duracao'] >= 4)]

hotspots.info()
describe = hotspots.describe()

plt.bar(hotspots['numero_ocorrencias'].value_counts().index, hotspots['numero_ocorrencias'].value_counts().values)
plt.xlabel('Numero de ocorrencias')
plt.ylabel('Numero de hotspots')
plt.title('Numero Ocorrencias dos hotspots')
plt.show()

plt.bar(hotspots['racio_ocorrencias_por_dia'].value_counts().index, hotspots['racio_ocorrencias_por_dia'].value_counts().values)
plt.xlabel('Numero de ocorrencias por dia')
plt.ylabel('Numero de hotspots')
plt.title('Racios de ocorrencias')
plt.show()

plt.bar(hotspots['duracao'].value_counts().index, hotspots['duracao'].value_counts().values)
plt.xlabel('Duração')
plt.ylabel('Numero de hotspots')
plt.title('Durações dos hotspots')
plt.show()




describe = hotspots.describe()

explor = hotspots['Freguesia'].value_counts()

top_50_hotspots = hotspots.nlargest(100, 'numero_ocorrencias')

# Get value counts of 'subseccao' and 'Freguesia' variables
subseccao_counts = top_50_hotspots['Subseccao'].value_counts()
freguesia_counts = top_50_hotspots['Freguesia'].value_counts()

print("Value Counts of 'subseccao' variable for Top 50 rows:")
print(subseccao_counts)
print("\nValue Counts of 'Freguesia' variable for Top 50 rows:")
print(freguesia_counts)

gdfm = gdfss.iloc[:, :-3]
hotspots_df = hotspots.merge(gdfm, on='Subseccao', how='left')

#Merge com dados do INE
hotspots_m = hotspots.merge(gdfss, on='Subseccao', how='left')
hotspots_m = gpd.GeoDataFrame(hotspots_m, geometry='geometry')




#%%
import geopandas as gpd
import folium 
from branca.colormap import StepColormap, LinearColormap

count_df = hotspots_m.groupby('Subseccao').size().reset_index(name='Hotspots')

# Merge count_df with geo_json_data on the common column "Freguesia"/"NOME"
merged_data = pd.merge(gdfss, count_df, left_on='Subseccao', right_on='Subseccao', how='left')
merged_data['Hotspots'] = merged_data['Hotspots'].fillna(0)
# Initialize Folium map centered at the mean of latitude and longitude of the GeoJSON data
m = folium.Map()

folium.Choropleth(
    geo_data=merged_data,
    data=merged_data,
    columns=['Subseccao', 'Hotspots'], 
    key_on='feature.properties.Subseccao',  
    fill_color='YlGn',  
    fill_opacity=1,
    line_opacity=0.2,
    highlight=True,
    legend_name='Numero de Hotspots',
).add_to(m)

m.save('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\mapa_subseccoes.html')


#stepcolormap
bins = [0, 1, 4, 7, 16, 31, 92]  # Bins include the upper bound of each range
colors = ['#ffffff', '#FFF8DC', '#FFEBCD', '#FFDEAD', '#F4A460', '#D2691E', '#8B0000']
colormap = StepColormap(
    colors=colors,
    index=bins,
    vmin=0,
    vmax=91,
    caption='Numero de Hotspots'  # Caption for the legend
)

# Create a base map
m = folium.Map(tiles=None)  # Adjust the location and zoom level

# Function to get the color for each hotspot value
def get_color(hotspot_value):
    return colormap(hotspot_value)

# Add GeoDataFrame to the map
folium.GeoJson(
    merged_data,
    style_function=lambda feature: {
        'fillColor': get_color(feature['properties']['Hotspots']),
        'color': 'black',
        'weight': 1,
        'fillOpacity': 1,
    },
    tooltip=folium.GeoJsonTooltip(fields=['Subseccao', 'Hotspots'])
).add_to(m)

# Add the colormap legend
colormap.add_to(m)

m.save('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\mapa_subseccoes.html')

#linear

colors = ['#ffffff', '#FFF8DC', '#FFEBCD', '#FFDEAD', '#F4A460', '#D2691E', '#8B0000', '#590059', '#300030', '#000000']

# Create a LinearColormap object
linear_colormap = LinearColormap(colors, vmin=0, vmax=91, index=[0, 1, 4, 9, 16, 25, 36, 49, 64, 91])

# Create a base map centered around Lisbon
lisbon_center = [38.7223, -9.1393]
m = folium.Map(location=lisbon_center, zoom_start=12)  # Adjust the location and zoom level

# Function to get the color for each hotspot value
def get_color(hotspot_value):
    if hotspot_value == 0:
        return '#ffffff' # Light greyish color for 0
    return linear_colormap(hotspot_value)

# Add GeoDataFrame to the map
folium.GeoJson(
    merged_data,
    style_function=lambda feature: {
        'fillColor': get_color(feature['properties'].get('Hotspots')),
        'color': 'black',
        'weight': 1,
        'fillOpacity': 0.5,
    },
    tooltip=folium.GeoJsonTooltip(fields=['Subseccao', 'Hotspots'])
).add_to(m)

# Add the colormap legend
linear_colormap.caption = 'Numero de Hotspots'
linear_colormap.add_to(m)

m.save('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\mapa_subseccoes.html')

#%%

#Mapa com numero de hotspots por freguesia

geo_json_data = gpd.read_file('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\dados\\Limite_Cartografia.geojson')

# Merge count_df with geo_json_data on the common column "Freguesia"/"NOME"
merged_data = pd.merge(geo_json_data, explor, left_on='NOME', right_on='Freguesia', how='left')

# Create the map
m = folium.Map(location=lisbon_center, zoom_start=12, tiles=None)

linear_colormap = LinearColormap(
    colors=['#fff5eb', '#fee6ce', '#fdd0a2', '#fdae6b', '#fd8d3c', '#f16913', '#d94801', '#8c2d04'],
    vmin=merged_data['count'].min(),
    vmax=merged_data['count'].max(),
    caption='Numero de Hotspots'  # Caption for the legend
)

# Add GeoJson with custom style function using the colormap
folium.GeoJson(
    merged_data,
    style_function=lambda feature: {
        'fillColor': linear_colormap(feature['properties']['count']),
        'color': 'black',
        'weight': 1,
        'fillOpacity': 1,
    },
    tooltip=folium.GeoJsonTooltip(fields=['NOME', 'count'])
).add_to(m)

# Add the colormap to the map
linear_colormap.add_to(m)

m.save('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\mapa_freguesias.html')

tiposhotspots = hotspots['tipo'].value_counts()

areashotspots = hotspots['area'].value_counts()

#Linear

colors = ['#ffffff', '#FFF8DC', '#FFEBCD', '#FFDEAD', '#F4A460', '#D2691E', '#8B0000', '#590059', '#300030', '#000000']

# Create a LinearColormap object
linear_colormap = LinearColormap(colors, vmin=0, vmax=merged_data['Hotspots'].max())

# Create a base map centered around Lisbon
lisbon_center = [38.7223, -9.1393]
m = folium.Map(location=lisbon_center, zoom_start=12)  # Adjust the location and zoom level

# Function to get the color for each hotspot value
def get_color(hotspot_value):
    if hotspot_value == 0:
        return '#ffffff' # Light greyish color for 0
    return linear_colormap(hotspot_value)

# Add GeoDataFrame to the map
folium.GeoJson(
    merged_data,
    style_function=lambda feature: {
        'fillColor': get_color(feature['properties'].get('Hotspots')),
        'color': 'black',
        'weight': 1,
        'fillOpacity': 0.5,
    },
    tooltip=folium.GeoJsonTooltip(fields=['Subseccao', 'Hotspots'])
).add_to(m)

# Add the colormap legend
linear_colormap.caption = 'Numero de Hotspots'
linear_colormap.add_to(m)

m.save('C:\\Users\\migue\\OneDrive\\Documentos\\ISCTE\\PFCD\\mapa_subseccoes.html')
